/* Copyright (c) 2000-2008 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */

// A project extension to manage project test plans

if (typeof(ko)=='undefined') {
    var ko = {};
}
if (typeof(ko.projects)=='undefined') {
    ko.projects = {};
}

(function() {
var _log = ko.logging.getLogger('peUnitTest');

function peUnitTest() {
    this.name = 'peUnitTest';
}

// The following two lines ensure proper inheritance (see Flanagan, p. 144).
peUnitTest.prototype.constructor = peUnitTest;

peUnitTest.prototype.init = function() {
    // register our command handlers
    this.registerCommands();
}

peUnitTest.prototype.registerCommands = function() {
    ko.projects.extensionManager.registerCommand('cmd_projectUnitTest_test_context', this);
}

peUnitTest.prototype.registerEventHandlers = function() {
}

peUnitTest.prototype.registerMenus = function() {
    setTimeout(function() {
            // setTimeout puts the menu item where we want it, not at the top
            var em = ko.projects.extensionManager;

            var menu = document.createElement("menu");
            menu.setAttribute('class','menu-iconic-wide');
            menu.setAttribute('label',
                              document.getElementById("menu_projectUnitTest_test").getAttribute("label"));
            var menupopup = document.createElement("menupopup");
            menupopup.setAttribute('id', 'context_menupopup_project_sleuth_testplans');
            menu.appendChild(menupopup);
            menupopup.setAttribute('onpopupshowing', 'ko.sleuth.manager.addProjectTestPlanNamesToPopup(event)');
            em.addMenuItem(Components.interfaces.koIProject, menu);
        }, 10);
}


peUnitTest.prototype.supportsCommand = function(command, /*koIPart*/ part) {
    //dump("peUnitTest.supportsCommand, cmd=" + command + "\n");
    if (command != "cmd_projectUnitTest_test_context") {
        return false;
    }
    var res = ko.sleuth.manager.getNumProjectTestPlans(part, 'prefset');
    //dump("peUnitTest.isCommandEnabled(part = "
    //     + part.name
    //     + ", res="
    //     + res
    //     + ")\n");
    return res > 0;
}

peUnitTest.prototype.isCommandEnabled = function(command, /*koIPart*/ part) {
    // dump("peUnitTest.isCommandEnabled, cmd=" + command + "\n");
    return command == "cmd_projectUnitTest_test_context";
}

// this is hidden away now, no namespace, the registration keeps the reference
// we need
ko.projects.registerExtension(new peUnitTest());

}).apply(ko.projects);
